package com.steerinfo.baseinfo.meterbasematterinfomatch.controller;

import com.steerinfo.baseinfo.meterbasematterinfomatch.model.MeterBaseMatterInfoMatch;
import com.steerinfo.baseinfo.meterbasematterinfomatch.service.IMeterBaseMatterInfoMatchService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseMatterInfoMatch RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2021-03-10 09:13
 * 类描述
 * 修订历史：
 * 日期：2021-03-10
 * 作者：generator
 * 参考：
 * 描述：MeterBaseMatterInfoMatch RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterbasematterinfomatchs")
public class MeterBaseMatterInfoMatchController extends BaseRESTfulController {

    @Autowired
    IMeterBaseMatterInfoMatchService meterBaseMatterInfoMatchService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasematterinfomatch:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseMatterInfoMatch> list = meterBaseMatterInfoMatchService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasematterinfomatch:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseMatterInfoMatch> list = meterBaseMatterInfoMatchService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterBaseMatterInfoMatch对象创建")
    @ApiImplicitParam(name = "meterBaseMatterInfoMatch", value = "详细实体meterBaseMatterInfoMatch", required = true, dataType = "MeterBaseMatterInfoMatch")
    //@RequiresPermissions("meterbasematterinfomatch:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterBaseMatterInfoMatch model) {
        try {
            MeterBaseMatterInfoMatch meterBaseMatterInfoMatch = meterBaseMatterInfoMatchService.add(model);
            return success(meterBaseMatterInfoMatch);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasematterinfomatch:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterBaseMatterInfoMatch meterBaseMatterInfoMatch = meterBaseMatterInfoMatchService.getById(id);
            return success(meterBaseMatterInfoMatch);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterBaseMatterInfoMatch信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseMatterInfoMatch", value = "详细实体meterBaseMatterInfoMatch", required = true, dataType = "MeterBaseMatterInfoMatch")
    })
    //@RequiresPermissions("meterbasematterinfomatch:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseMatterInfoMatch model) {
        try {
            model.setId(id);
            MeterBaseMatterInfoMatch meterBaseMatterInfoMatch = meterBaseMatterInfoMatchService.modify(model);
            return success(meterBaseMatterInfoMatch);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasematterinfomatch:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterBaseMatterInfoMatchService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "新增关联", notes = "根据MeterBaseLoadUserloadinfo对象创建；数据来源meter_base_load_point；sso用户表")
    @ApiImplicitParam(name = "MeterBaseLoadUserloadinfo", value = "详细实体MeterBaseLoadUserloadinfo", required = true, dataType = "MeterBaseLoadUserloadinfo")
    @PostMapping(value = "relation")
    public RESTfulResult relation(@RequestBody List<MeterBaseMatterInfoMatch> models) {
        try {
            RESTfulResult rm = failed();
            try {
                int num = meterBaseMatterInfoMatchService.relation(models);
                return success(num);
            } catch (MarkerMetException e) {
                e.printStackTrace();
                rm.setMessage(e.getMessage());
            } catch (Exception e) {
                e.printStackTrace();
                rm.setMessage("操作异常，请确认！");
            } finally {

            }
            return rm;
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }
}